newTalentType{ allow_random=true, type="cunning/tourist", name = "tourist", description = "Tourist things" }

tourists_req1 = {
	stat = { wil=function(level) return 12 + (level-1) * 2 end },
	level = function(level) return 0 + (level-1)  end,
}
tourists_req2 = {
	stat = { wil=function(level) return 20 + (level-1) * 2 end },
	level = function(level) return 4 + (level-1)  end,
}
tourists_req3 = {
	stat = { wil=function(level) return 28 + (level-1) * 2 end },
	level = function(level) return 8 + (level-1)  end,
}
tourists_req4 = {
	stat = { wil=function(level) return 36 + (level-1) * 2 end },
	level = function(level) return 12 + (level-1)  end,
}

newTalent{ -- TODO: somehow buggy, affecting autoexplore and some traps
   name = "AutoCombat",
   type = {"base/class", 1},
   no_energy = "fake",
   innate = true,
   no_unlearn_last = true,
   description = "if hostiles are in fov and are in range of your weapon, use it otherwise move towards them",
   points = 1,
   require = tourists_req1,
   no_npc_use = true, -- tiger_eye wanted this :o
   action = function(self, t)
      -- spotHostiles in Player.lua
      local targets = {}

      core.fov.calc_circle(
	 self.x,
	 self.y,
	 game.level.map.w,
	 game.level.map.h,
	 self.sight or 10,
	 function(_, x, y)
	    return game.level.map:opaque(x, y)
	 end,
	 function(_, x, y)
	    local actor = game.level.map(x, y, game.level.map.ACTOR)
	    if actor and self:reactionToward(actor) < 0 and self:canSee(actor) and game.level.map.seens(x, y) then
	       targets[#targets + 1] = {x=x, y=y, actor=actor}
	    end
	 end,
	 nil)

      if #targets > 0 then

	 local target = targets[1]
	 -- if we have multiple targets, find a closest one
	 if #targets > 1 then
	    for i=2,#targets,1 do
	       if core.fov.distance(self.x, self.y, targets[i].x, targets[i].y) <
		  core.fov.distance(self.x, self.y, target.x, target.y) then
		  target = targets[i]
	       end
	    end
	 end

	 -- get weapon range
	 local range = 1
	 if self:hasArcheryWeapon() then
	    range = self:hasArcheryWeapon().combat.range
	 end

	 -- get some bling bling! (tiger_eye) :3
	 target.actor:addParticles(engine.Particles.new("notice_enemy", 1))
	 -- if in range of enemy
	 if core.fov.distance(self.x, self.y, target.x, target.y) <= range then
	    -- use shoot if we have a bow, otherwise attack
	    if self:hasArcheryWeapon() then
	       self:forceUseTalent(
		  self.T_SHOOT,
		  {force_target =
		   {x = target.x,
		    y = target.y,
		    __no_self = true}})
	    else
	       self:forceUseTalent(
		  self.T_ATTACK,
		  {force_target =
		   {x = target.x,
		    y = target.y,
		    __no_self = true}})
	    end
	 else
	    -- timed_effects/mental.lua
	    self.aiCanPass = mod.class.NPC.aiCanPass
	    mod.class.NPC.moveDirection(self, target.x, target.y, false)
	 end
      end
   end,
   info = function(self, t)
      return ([[if hostiles are in fov and are in range of your weapon, use it otherwise move towards them]])
   end,
}

newTalent{
	name = "Sight Seeing",
	type = {"cunning/tourist", 1},
	require = tourists_req1,
	points = 5,
	stamina = 8,
	cooldown = 10,
	range = 100,
	radius = function(self, t) return math.ceil(3 + self:getTalentLevel(t)) end,
	requires_target = true,
	no_npc_use = true,
	action = function(self, t)
		local x, y = self:getTarget{type="ball", nolock=true, no_restrict=true, nowarning=true, range=100, radius=self:getTalentRadius(t)}
		if not x then return nil end

		self:magicMap(math.ceil(3 + self:getTalentLevel(t)), x, y)
		game:playSoundNear(self, "talents/spell_generic2")
		return true
	end,
	info = function(self, t)
		local radius = self:getTalentRadius(t)
		return ([[See remote areas in a radius of %d.]]):
		format(radius)
	end,
}

newTalent{
	name = "Tourist Fury",
	type = {"cunning/tourist", 2},
	require = tourists_req2,
	points = 5,
	stamina = 20,
	cooldown = 30,
	action = function(self, t)
		self:setEffect(self.EFF_TOURIST_FURY, math.ceil(5 + self:getTalentLevel(t)), {})
		game:playSoundNear(self, "talents/spell_generic2")
		return true
	end,
	info = function(self, t)
		return ([[Multiply all damage done by 500%% for %d turns.]]):
		format(math.ceil(5 + self:getTalentLevel(t)))
	end,
}

newTalent{
	name = "Diplomatic Immunity",
	type = {"cunning/tourist", 3},
	require = tourists_req3,
	points = 5,
	stamina = 20,
	cooldown = 30,
	action = function(self, t)
		self:setEffect(self.EFF_DIPLOMATIC_IMMUNITY, math.ceil(5 + self:getTalentLevel(t)), {})
		game:playSoundNear(self, "talents/spell_generic2")
		return true
	end,
	info = function(self, t)
		return ([[Become immune to all damage for %d turns.]]):
		format(math.ceil(5 + self:getTalentLevel(t)))
	end,
}
newTalent{
	name = "Test Talent",
	type = {"cunning/tourist", 4},
	require = tourists_req4,
	points = 5,
	random_ego = "attack",
	stamina = 20,
	cooldown = 3,
	range = 10,
	requires_target = true,
	target = function(self, t)
		local tg = {type="bolt", range=self:getTalentRange(t), talent=t}
		return tg
	end,
	getDamage = function(self, t) return self:combatTalentSpellDamage(t, 20, 230) end,
	action = function(self, t)
		local tg = self:getTalentTarget(t)
		local x, y = self:getTarget(tg)
		if not x or not y then return nil end
		self:project(tg, x, y, DamageType.PINNING_VINE, self:spellCrit(t.getDamage(self, t)), nil)
		local _ _, x, y = self:canProject(tg, x, y)
		game.level.map:particleEmitter(x, y, 1, "manathrust")
		game:playSoundNear(self, "talents/arcane")
		return true
	end,
	info = function(self, t)
		local damage = t.getDamage(self, t)
		return ([[deals %0.2f physical damage.
		and pins
		The damage will increase with your Spellpower.]]):
		format(damage)
	end,
}
